package net.jaekl.cfb.db;

public class Condition {

	Column m_column;
	Object m_value;
	Operation m_operation;
	
	public Condition(Column column, Object value, Operation operation)
	{
		m_column = column;
		m_value = value;
		m_operation = operation;
		
		if ((null == m_value) && (Operation.EQUAL == m_operation)) {
			m_operation = Operation.NULL;
		}
	}
	
	public Condition(Column column, Object value) {
		this(column, value, Operation.EQUAL);
	}
	
	public Condition(Column column, Operation operation) {
		this(column, null, operation);
		
		assert(Operation.NULL == operation || Operation.NOT_NULL == operation);
	}
	
	public Column getColumn() { return m_column; }
	public Object getValue() { return m_value; }
	public Operation getOperation() { return m_operation; }
	
	@Override
	public String toString() {
		return ("(" + m_column.getName() + " " + m_operation + " " + m_value + ")");
	}
}
